package org.jtag.dialog;

import java.awt.*;
import java.awt.image.*;
import java.awt.event.*;
import java.util.*;
import java.io.*;
import java.net.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.text.html.*;


public class JTagContentsDialog extends JFrame 
    implements HyperlinkListener {

    private static boolean alreadyRunning = false;	
	
    JEditorPane htmlViewer;	
	
    public JTagContentsDialog(String title) {
        Image frameImage = Toolkit.getDefaultToolkit().getImage("images" + File.separator + "play.gif");

        this.setIconImage(frameImage);

        if (alreadyRunning) {
            this.dispose();
            return;
        }
   	
        alreadyRunning = true;
   	
        setTitle(title);
      
        JPanel contentPane = (JPanel) getContentPane();
      
        htmlViewer = new JEditorPane();
        JScrollPane scroller = new JScrollPane(htmlViewer);
       
        String urlString = "file:///";

        urlString = urlString + System.getProperty("user.dir");
        urlString = urlString + File.separator + "html"; 
        urlString = urlString + File.separator + "JTag.html";
   	  
        try {
            htmlViewer.setPage(urlString);
        } catch (Exception e) {
            System.out.println("Invalid destination string");
        }
   	 
        htmlViewer.setEditable(false);
        htmlViewer.addHyperlinkListener(this);
   	 
        contentPane.add(scroller);
   	
        this.setSize(600, 400);
        this.show();
   	
        // Windows listener
        this.addWindowListener(new WindowAdapter() {
                public void windowClosing(WindowEvent e) {
                    alreadyRunning = false;
                }
            }
        );			

    }	
  
    public void hyperlinkUpdate(HyperlinkEvent e) {
        if (e.getEventType() == HyperlinkEvent.EventType.ACTIVATED) {
            JEditorPane pane = (JEditorPane) e.getSource();

            if (e instanceof HTMLFrameHyperlinkEvent) {
                HTMLFrameHyperlinkEvent  evt = (HTMLFrameHyperlinkEvent) e;
                HTMLDocument doc = (HTMLDocument) pane.getDocument();

                doc.processHTMLFrameHyperlinkEvent(evt);
            } else {
                try {
                    pane.setPage(e.getURL());
                } catch (Throwable t) {
                    t.printStackTrace();
                }
            }
        }
    }
}
