package org.jtag.dnd;

import java.awt.*;
import java.awt.dnd.*;
import java.awt.datatransfer.*;
import java.io.*;
import java.util.*;
import javax.swing.*;


public class TargetList extends JList implements 
        DropTargetListener {
    private DropTarget mTarget;
    public Vector listData = new Vector();
   
    public TargetList() {
        super();

        // Create the DropTarget, passing in the component it
        // is associated with, and the class that implements 
        // the DropTargetListener interface.
      
        mTarget = new DropTarget(this, this);

    }

    // NEW
    public void dropActionChanged(DropTargetDragEvent e) {}
	
    // This is called when the drag cursor enters the 
    // component.  We call the DropTargetDragEvent's 
    // acceptDrag() method to tell the DropTargetContext 
    // that this component will accept ACTION_COPY type 
    // drops only.
   
    public void dragEnter(DropTargetDragEvent e) {
        e.acceptDrag(DnDConstants.ACTION_COPY_OR_MOVE);
    }

    // This is called when the drag cursor exits the 
    // component.
   
    public void dragExit(DropTargetEvent e) {}

    // This is called when the drag cursor drags over the 
    // component.
   
    public void dragOver(DropTargetDragEvent e) {}

    // This is called when the drag cursor causes the 
    // component to scroll.
   
    public void dragScroll(DropTargetDragEvent e) {}

    // This is called when the drop occurs.
   
    public void drop(DropTargetDropEvent e) {
        // Get the Transferable.
      
        Transferable tr = e.getTransferable();

        // If the Transferable's data can be delivered in the
        // format we understand, we can continue.
      
        if (tr.isDataFlavorSupported( 
                DataFlavor.stringFlavor)) {
            // Accept the drop.
         
            e.acceptDrop(DnDConstants.ACTION_MOVE);
    
            try {
                // Get the dragged data from the Transferable.
            
                DataFlavor[] dfs = e.getCurrentDataFlavors();
                StringReader reader = (StringReader) dfs[0].getReaderForText(tr);
            
                // Read the item into a character array and add
                // it as a list item.
            
                char ch[] = new char[100];
                int len;
            
                len = reader.read(ch);
            
                listData.add(new String(ch, 0, len));
                this.setListData(listData);

            } catch (UnsupportedFlavorException ex) {
                ex.printStackTrace();
            } catch (IOException ex) {
                ex.printStackTrace();
            }
         
            // Notify the DropTargetContext that the drop is 
            // successfully complete.
         
            e.getDropTargetContext().dropComplete(true);
        } else {
            // We couldn't get the data, so we reject the drop.
         
            e.rejectDrop();
        }
    }
}
