package org.jtag.id3;

import java.util.*;


/**
 * Class which holds ID3 genre definitions.
 *
 */
public class id3Genre {

    /**
     * Array defining all possible genres
     *
     */
    public String genre[] = {
            "Blues", "Classic Rock", "Country", "Dance", "Disco", "Funk", 
            "Grunge", "Hip-Hop", "Jazz", "Metal", "New Age", "Oldies", 
            "Other", "Pop", "R&B", "Rap", "Reggae", "Rock", "Techno", 
            "Industrial", "Alternative", "Ska", "Death Metal", "Pranks", 
            "Soundtrack", "Euro-Techno", "Ambient", "Trip-Hop", "Vocal", 
            "Jazz+Funk", "Fusion", "Trance", "Classical", "Instrumental",
            "Acid", "House", "Game", "Sound Clip", "Gospel", "Noise", 
            "AlternRock", "Bass", "Soul", "Punk", "Space", "Meditative", 
            "Instrumental Pop", "Instrumental Rock", "Ethnic", "Gothic", 
            "Darkwave", "Techno-Industrial", "Electronic", "Pop-Folk", 
            "Eurodance", "Dream", "Southern Rock", "Comedy", "Cult", 
            "Gangsta", "Top 40", "Christian Rap", "Pop/Funk", "Jungle", 
            "Native American", "Cabaret", "New Wave", "Psychadelic", 
            "Rave", "Showtunes", "Trailer", "Lo-Fi", "Tribal", "Acid Punk", 
            "Acid Jazz", "Polka", "Retro", "Musical", "Rock & Roll", 
            "Hard Rock", "Folk", "Folk/Rock", "National Folk", "Swing", 
            "Bebob", "Latin", "Revival", "Celtic", "Bluegrass", "Avantgarde", 
            "Gothic Rock", "Progressive Rock", "Psychedelic Rock", 
            "Symphonic Rock", "Slow Rock", "Big Band", "Chorus", 
            "Easy Listening", "Acoustic", "Humour", "Speech",
            "Chanson", "Opera", "Chamber Music", "Sonata", "Symphony", 
            "Booty Bass", "Primus", "Porn Groove", "Satire", "Slow Jam", 
            "Club", "Tango", "Samba", "Folklore"
        };
 	
    /**
     * Method returning the genre array.
     *
     */
    public String[] getList() {
        return genre;
    } 	
 	
    /**
     * Method returning the sorted genre array.
     *
     */
    public String[] getSortedList() {
 	 
        String sortedStrings[] = new String[genre.length];

        sortedStrings = genre;
        int a, b;

        for (a = 1; a < sortedStrings.length; a++)
            for (b = sortedStrings.length - 1; b >= a; b--) {
                if (sortedStrings[b - 1].compareTo(sortedStrings[b]) > 0) {
                    String tmp = new String(sortedStrings[b - 1]);

                    sortedStrings[b - 1] = sortedStrings[b];
                    sortedStrings[b] = tmp;
                }
            }
 	 	  
        return sortedStrings;	
    }
 	
    /**
     * Method returning the genre list as hash.
     * Key is the genre name. The value being the genre index.
     *
     */
    public Hashtable returnHashtable() {
        Hashtable hashtable = new Hashtable();

        for (int i = 0; i < genre.length; i++) {
            hashtable.put(genre[i], new Integer(i));
        }
   
        return hashtable;
    }
   
} 


