package org.jtag;

import java.awt.*;
import java.awt.event.*;
import java.awt.print.*;
import java.lang.Runtime;
import java.io.*;
import java.util.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.table.*;
import javax.swing.border.*;
import java.util.*;

import org.jtag.dialog.*;
import org.jtag.dnd.*;
import org.jtag.id3.*;
import org.jtag.io.*;
import org.jtag.mp3.*;
import org.jtag.table.*;
import org.jtag.tools.concat.*;

import sunlabs.brazil.util.regexp.Regexp;


public class mainWindow extends JFrame implements ActionListener,
        Runnable, ItemListener, ListSelectionListener {
    public JTabbedPane mTabbedPane;
    public JPanel mTablePanel;
    public JPanel mErrorPanel;
    public JTextArea mTextArea;
    public JTagTable mTable;
    public JScrollPane mTextAreaScroller;
    public JProgressBar mProgressBar;
    public JToolBar mToolBar;
    private Thread mThread;
    private String mAction;

    private File mCurrentFileDir;

    private JButton playButton, saveDbButton;
    public JButton syncButton;
    public Button dummySyncButton;
    private JMenuItem playItem, saveDbItem;

    private JTagPrefs prefs;

    public JTagGenreList genreDialog;

    public Vector fileVector = new Vector();

    public JTagInsertDialog insertDialog = null;

    public JTagCopyColumnDialog copyColumnDialog = null;

    public JTagReplaceDialog  replaceDialog = null;

    public JTagGenerateFromFilenameDialog generateDialog = null;

    public JTagGenerateFilenameDialog generateFilenameDialog = null;

    public JTagConvertCaseDialog convertCaseDialog = null;

    // No longer needed
    //public Hashtable fileHash = new Hashtable();

    private JCheckBoxMenuItem sizeTableItem;
    private JCheckBoxMenuItem showStatusbarItem;
    private JCheckBoxMenuItem showToolbarItem;
    private JCheckBoxMenuItem genreListItem;
    private JCheckBoxMenuItem recurseDirsItem;
    private JCheckBoxMenuItem showDirColumnItem;

    Hashtable topOfCombo = new Hashtable();
    Vector comboVect = new Vector();

    // These are the variables set by the preferences
    String mMpPlayer;
    public Vector mOutputVector = new Vector();
    String mSepCharacter = new String();
    String mDbUser = new String();
    String mDbURL = new String();
    String mDbDriver = new String();

    // Thread for autosaving
    autoSave asave;
    long aSaveInterval;

    public mainWindow(String title) {
        super(title);
        mMpPlayer = null;

        //JOptionPane.showMessageDialog(this,
        //  "No MP3 Player specified in parameter list. Play function will be disabled");

        //mThread = new Thread(this);
        //mThread.start();
        //doUI();


    }

    public mainWindow(String title, String player) {
        super(title);
        mMpPlayer = player;

        //mThread = new Thread(this);
        //mThread.start();
        //doUI();


    }

    public void doUI() {
        Image frameImage = Toolkit.getDefaultToolkit().getImage("images" + File.separator + "play.gif");

        this.setIconImage(frameImage);

        // Enable autosaving
        if (aSaveInterval > 0)
            asave = new autoSave(aSaveInterval, this);

        // Display this image as frame Icon
        //Image frameImage = Toolkit.getDefaultToolkit().getImage("images/frameLogo.jpg");
        //this.setIconImage(frameImage);

        // Create the genre list dialog
        genreDialog =
                new JTagGenreList("Genre list", "Already selected genre list",
                    true, this);

        genreDialog.addWindowListener(new genreWindowAdapter());
        genreDialog.genreList.getSelectionModel().addListSelectionListener(this);

        JPanel contentPane = (JPanel) getContentPane();

        mTabbedPane = new JTabbedPane();
        mTabbedPane.setPreferredSize(null);

        mTablePanel = new JPanel();
        mTablePanel.setLayout(new BorderLayout());
        mTabbedPane.addTab("MP3 list", mTablePanel);

        mErrorPanel = new JPanel();
        mErrorPanel.setLayout(new BorderLayout());
        mTabbedPane.addTab("Error list", mErrorPanel);
        mTextArea = new JTextArea(20, 40);
        mTextAreaScroller = new JScrollPane(mTextArea);

        mErrorPanel.add("Center", mTextAreaScroller);

        mTabbedPane.setSelectedIndex(0);

        contentPane.add("Center", mTabbedPane);

        //Create a progressbar and add it
        mProgressBar = new JProgressBar();
        mProgressBar.setBorder(new BevelBorder(BevelBorder.RAISED));
        contentPane.add("South", mProgressBar);

        // add menubar
        JMenuBar menuBar = new JMenuBar();

        this.getRootPane().setJMenuBar(menuBar);

        // add file menu
        JMenu fileMenu = new JMenu("File");

        menuBar.add(fileMenu);
        JMenuItem openItem =
            new JMenuItem("Open directory", new ImageIcon("images/open.gif"));

        openItem.addActionListener(this);
        openItem.setActionCommand("Open");

        JMenuItem reloadItem =
            new JMenuItem("Reload directory", new ImageIcon("images/reload.gif"));

        reloadItem.addActionListener(this);
        reloadItem.setActionCommand("Reload");

        JMenuItem saveItem = new JMenuItem("Save list", new ImageIcon("images/save.gif"));

        saveItem.addActionListener(this);
        saveItem.setActionCommand("Save");

        saveDbItem =
                new JMenuItem("Export into database", new ImageIcon("images/savedb.gif"));
        saveDbItem.addActionListener(this);
        saveDbItem.setActionCommand("SaveDb");

        // If no DB driver or URL is given
        if (mDbURL == null || mDbDriver == null || mDbURL.length() == 0 ||
            mDbDriver.length() == 0) {
            saveDbItem.setEnabled(false);
        }

        JMenuItem exitItem = new JMenuItem("Exit");

        exitItem.addActionListener(this);
        exitItem.setActionCommand("Exit");

        fileMenu.add(openItem);
        fileMenu.add(saveItem);
        fileMenu.add(saveDbItem);
        fileMenu.add(reloadItem);
        fileMenu.addSeparator();
        fileMenu.add(exitItem);

        // add edit menu
        JMenu editMenu = new JMenu("Edit");

        menuBar.add(editMenu);

        JMenuItem insertItem = new JMenuItem("Insert...");

        insertItem.addActionListener(this);
        insertItem.setActionCommand("Insert");

        JMenuItem replaceItem = new JMenuItem("Replace...");

        replaceItem.addActionListener(this);
        replaceItem.setActionCommand("Replace");

        JMenuItem copyColumnItem = new JMenuItem("Copy column...");

        copyColumnItem.addActionListener(this);
        copyColumnItem.setActionCommand("CopyColumn");

        JMenuItem convertCaseItem = new JMenuItem("Convert case...");

        convertCaseItem.addActionListener(this);
        convertCaseItem.setActionCommand("ConvertCase");

        JMenuItem generateFilenameItem = new JMenuItem("Auto-generate filename...");

        generateFilenameItem.addActionListener(this);
        generateFilenameItem.setActionCommand("Auto-generateFilename");

        JMenuItem generateFromFilenameItem = new JMenuItem("Generate from filename...");

        generateFromFilenameItem.addActionListener(this);
        generateFromFilenameItem.setActionCommand("GenerateFromFilename");

        playItem = new JMenuItem("Play", new ImageIcon("images/play.gif"));
        playItem.addActionListener(this);
        playItem.setActionCommand("Play");

        JMenuItem headerItem =
            new JMenuItem("Mp3 header", new ImageIcon("images/info.gif"));

        headerItem.addActionListener(this);
        headerItem.setActionCommand("Mp3Header");

        JMenuItem syncItem = new JMenuItem("Sync files", new ImageIcon("images/sync.gif"));

        syncItem.addActionListener(this);
        syncItem.setActionCommand("Sync");

        JMenuItem syncSelItem =
            new JMenuItem("Sync selected files", new ImageIcon("images/syncSel.gif"));

        syncSelItem.addActionListener(this);
        syncSelItem.setActionCommand("Sync selected");

        JMenuItem preferencesItem = new JMenuItem("Preferences...");

        preferencesItem.addActionListener(this);
        preferencesItem.setActionCommand("Preferences");

        JMenuItem SavePrefsItem = new JMenuItem("Save preferences");

        SavePrefsItem.addActionListener(this);
        SavePrefsItem.setActionCommand("SavePrefs");

        editMenu.add(insertItem);
        editMenu.add(replaceItem);
        editMenu.addSeparator();
        editMenu.add(copyColumnItem);
        editMenu.add(convertCaseItem);
        editMenu.addSeparator();
        editMenu.add(generateFilenameItem);
        editMenu.add(generateFromFilenameItem);
        editMenu.addSeparator();

        editMenu.add(headerItem);

        if (mMpPlayer == null)
            playItem.setEnabled(false);
        editMenu.add(playItem);

        editMenu.add(syncItem);
        editMenu.add(syncSelItem);
        editMenu.addSeparator();
        editMenu.add(preferencesItem);
        editMenu.add(SavePrefsItem);

        // add a toolbar
        mToolBar = new JToolBar();
        // Toolbat stiks to top of window
        mToolBar.setFloatable(false);

        contentPane.add("North", mToolBar);
        JButton openButton = new JButton(new ImageIcon("images/open.gif"));

        openButton.setMargin(new Insets(0, 0, 0, 0));
        openButton.setToolTipText("Open directory");
        openButton.addActionListener(this);
        openButton.setActionCommand("Open");
        mToolBar.add(openButton);

        mToolBar.addSeparator();

        JButton saveButton = new JButton(new ImageIcon("images/save.gif"));

        saveButton.setMargin(new Insets(0, 0, 0, 0));
        saveButton.setToolTipText("Save table to file");
        saveButton.addActionListener(this);
        saveButton.setActionCommand("Save");
        mToolBar.add(saveButton);

        saveDbButton = new JButton(new ImageIcon("images/savedb.gif"));
        saveDbButton.setMargin(new Insets(0, 0, 0, 0));
        saveDbButton.setToolTipText("Export table into database");
        saveDbButton.addActionListener(this);
        saveDbButton.setActionCommand("SaveDb");
        mToolBar.add(saveDbButton);

        // If no DB driver or URL is given
        if (mDbURL == null || mDbDriver == null || mDbURL.length() == 0 ||
            mDbDriver.length() == 0) {
            saveDbButton.setEnabled(false);
        }

        mToolBar.addSeparator();

        JButton reloadButton = new JButton(new ImageIcon("images/reload.gif"));

        reloadButton.setMargin(new Insets(0, 0, 0, 0));
        reloadButton.setToolTipText("Reload directory");
        reloadButton.addActionListener(this);
        reloadButton.setActionCommand("Reload");
        mToolBar.add(reloadButton);

        mToolBar.addSeparator();

        syncButton = new JButton(new ImageIcon("images/sync.gif"));
        syncButton.setMargin(new Insets(0, 0, 0, 0));
        syncButton.setToolTipText("Sync table with files");
        syncButton.addActionListener(this);
        syncButton.setActionCommand("Sync");
        mToolBar.add(syncButton);

        // Dummy button to allow autosaving
        // Swing components seem to handle events differently
        dummySyncButton = new Button();
        dummySyncButton.addActionListener(this);
        dummySyncButton.setActionCommand("Sync");

        JButton syncSelButton = new JButton(new ImageIcon("images/syncSel.gif"));

        syncSelButton.setMargin(new Insets(0, 0, 0, 0));
        syncSelButton.setToolTipText("Sync table selection(s) with file(s)");
        syncSelButton.addActionListener(this);
        syncSelButton.setActionCommand("Sync selected");
        mToolBar.add(syncSelButton);

        mToolBar.addSeparator();

        playButton = new JButton(new ImageIcon("images/play.gif"));
        playButton.setMargin(new Insets(0, 0, 0, 0));
        playButton.setToolTipText("Play selection");
        playButton.addActionListener(this);
        playButton.setActionCommand("Play");

        if (mMpPlayer == null)
            playButton.setEnabled(false);

        JButton headerButton = new JButton(new ImageIcon("images/info.gif"));

        headerButton.setMargin(new Insets(0, 0, 0, 0));
        headerButton.setToolTipText("Show Mp3 header info");
        headerButton.addActionListener(this);
        headerButton.setActionCommand("Mp3Header");

        mToolBar.add(headerButton);

        mToolBar.addSeparator();

        mToolBar.add(playButton);

        // add options menu
        JMenu optionsMenu = new JMenu("Options");

        menuBar.add(optionsMenu);

        sizeTableItem = new JCheckBoxMenuItem("Size table to window", false);
        sizeTableItem.addItemListener(this);

        genreListItem =
                new JCheckBoxMenuItem("Show alread selected genre list",
                    false);
        genreListItem.addItemListener(this);

        recurseDirsItem =
                new JCheckBoxMenuItem("Include subdirectories", false);
        recurseDirsItem.addItemListener(this);

        showDirColumnItem =
                new JCheckBoxMenuItem("Show directory column", false);
        showDirColumnItem.addItemListener(this);

        showToolbarItem = new JCheckBoxMenuItem("Show Toolbar", true);
        showToolbarItem.addItemListener(this);

        showStatusbarItem = new JCheckBoxMenuItem("Show Statusbar", true);
        showStatusbarItem.addItemListener(this);

        optionsMenu.add(sizeTableItem);
        optionsMenu.add(showDirColumnItem);
        optionsMenu.addSeparator();
        optionsMenu.add(genreListItem);
        optionsMenu.addSeparator();
        optionsMenu.add(recurseDirsItem);
        optionsMenu.addSeparator();
        optionsMenu.add(showToolbarItem);
        optionsMenu.add(showStatusbarItem);
        // -- End of options menu

        // add tools menu
        JMenu toolsMenu = new JMenu("Tools");

        menuBar.add(toolsMenu);

        JMenuItem concatMp3sItem = new JMenuItem("Concat MP3s...");

        concatMp3sItem.addActionListener(this);
        concatMp3sItem.setActionCommand("ConcatMP3s");

        toolsMenu.add(concatMp3sItem);
        //- End of tools menu

        // add help menu
        JMenu helpMenu = new JMenu("Help");

        menuBar.add(helpMenu);

        JMenuItem aboutItem = new JMenuItem("About");

        aboutItem.addActionListener(this);
        aboutItem.setActionCommand("About");

        JMenuItem docuItem = new JMenuItem("Documentation");

        docuItem.addActionListener(this);
        docuItem.setActionCommand("Documentation");

        helpMenu.add(docuItem);
        helpMenu.addSeparator();
        helpMenu.add(aboutItem);

        // -- End of help menu
 
    
     


        // Windows listener
        this.addWindowListener(new WindowAdapter() {
                public void windowClosing(WindowEvent e) {
                    // Stop the autosave thread
                    if (aSaveInterval > 0)
                        asave.stop = true;
                    System.exit(0);
                }
            }
        );

    }

    // --- End of preferences section


    public void actionPerformed(ActionEvent e) {

        // --- Events returned from preferences menu
        if (e.getActionCommand().equals("PrefsCancel")) {
            prefs.dispose();
            return;
        }

        if (e.getActionCommand().equals("PrefsOk")) {
            setPreferences();
            return;
        }

        if (e.getActionCommand().equals("InsertOk")) {
            if (mTable == null)
                return;

            // Get selected index
            int insertSelectedIndex = insertDialog.choice.getSelectedIndex();

            TableModel model = mTable.getModel();

            //TableColumnModel colModel = mTable.getColumnModel();

            // Check if the whole table has to be updated
            if (insertDialog.allButton.isSelected()) {
                int numRows = mTable.getRowCount();

                for (int row = 0; row < numRows; row++) {
                    model.setValueAt(
                        (String) insertDialog.textField.getText(), row,
                        insertSelectedIndex);
                    mTable.editCellAt(row, insertSelectedIndex);
                    mTable.getCellEditor().stopCellEditing();
                }
            } else {
                int selectedRows[] = mTable.getSelectedRows();

                // if now rows have been selected return
                if (selectedRows.length == 0)
                    return;

                for (int i = 0; i < selectedRows.length; i++) {
                    int row = selectedRows[i];

                    model.setValueAt(
                        (String) insertDialog.textField.getText(), row,
                        insertSelectedIndex);
                    mTable.editCellAt(row, insertSelectedIndex);
                    mTable.getCellEditor().stopCellEditing();
                }
            }

            mTable.repaint();
            this.repaint();
            return;
        }

        if (e.getActionCommand().equals("InsertCancel")) {
            insertDialog.setVisible(false);
            this.repaint();
            return;
        }

        if (e.getActionCommand().equals("ComboChanged")) {
            updateGenreList();
        }

        if (e.getActionCommand().equals("Insert")) {
            this.repaint();

            if (insertDialog == null) {
                insertDialog = new JTagInsertDialog("Insert", false, false);
                insertDialog.setSize(300, 215);
                insertDialog.allButton.setSelected(true);
                insertDialog.choice.addItem("Song title");
                insertDialog.choice.addItem("Artist");
                insertDialog.choice.addItem("Album");
                insertDialog.choice.addItem("Year");
                insertDialog.choice.addItem("Comment");

                insertDialog.okButton.addActionListener(this);
                insertDialog.okButton.setActionCommand("InsertOk");

                insertDialog.cancelButton.addActionListener(this);
                insertDialog.cancelButton.setActionCommand("InsertCancel");

                insertDialog.setLocationRelativeTo(this);
            }
            insertDialog.setVisible(true);
        }

        if (e.getActionCommand().equals("Replace")) {
            this.repaint();

            if (replaceDialog == null) {
                replaceDialog = new JTagReplaceDialog("Replace", false, false);
                replaceDialog.setSize(300, 215);
                replaceDialog.allButton.setSelected(true);
                replaceDialog.choice.addItem("Song title");
                replaceDialog.choice.addItem("Artist");
                replaceDialog.choice.addItem("Album");
                replaceDialog.choice.addItem("Year");
                replaceDialog.choice.addItem("Comment");
                replaceDialog.choice.addItem("Filename");

                replaceDialog.okButton.addActionListener(this);
                replaceDialog.okButton.setActionCommand("ReplaceOk");

                replaceDialog.cancelButton.addActionListener(this);
                replaceDialog.cancelButton.setActionCommand("ReplaceCancel");

                replaceDialog.setLocationRelativeTo(this);
            }
            replaceDialog.setVisible(true);
        }

        if (e.getActionCommand().equals("ReplaceCancel")) {
            replaceDialog.setVisible(false);
            this.repaint();
            return;
        }

        if (e.getActionCommand().equals("ReplaceOk")) {
            if (mTable == null)
                return;

            // Get selected index
            int selectedIndex = replaceDialog.choice.getSelectedIndex();

            // If filename set selectedIndex to 6 (Genre is missing)
            if (selectedIndex == 5)
                selectedIndex = 6;
      
            TableModel model = mTable.getModel();

            //TableColumnModel colModel = mTable.getColumnModel();

            // Check if the whole table has to be updated
            if (replaceDialog.allButton.isSelected()) {
                int numRows = mTable.getRowCount();

                for (int row = 0; row < numRows; row++) {
                    String sourceString = (String) model.getValueAt(row, selectedIndex);
 
                    String resultString;

                    if (replaceDialog.regCheckbox.isSelected()) {
                        // Handle regualar expression, case sensitive
                        Regexp reg = new Regexp(replaceDialog.sourceField.getText(), false);

                        resultString = reg.subAll(sourceString, replaceDialog.targetField.getText());
                    } else {
                        StringBuffer resultStringBuffer = new StringBuffer(sourceString);

                        replace(resultStringBuffer, replaceDialog.sourceField.getText(), 
                            replaceDialog.targetField.getText(), true);
                        resultString = (String) resultStringBuffer.toString();
                    }

                    model.setValueAt(
                        (String) resultString, row,
                        selectedIndex);
                    mTable.editCellAt(row, selectedIndex);
                    mTable.getCellEditor().stopCellEditing();

                }
            } else {
                int selectedRows[] = mTable.getSelectedRows();

                // if now rows have been selected return
                if (selectedRows.length == 0)
                    return;

                for (int i = 0; i < selectedRows.length; i++) {
                    int row = selectedRows[i];
               
                    String sourceString = (String) model.getValueAt(row, selectedIndex);

                    String resultString;

                    if (replaceDialog.regCheckbox.isSelected()) {
                        // Handle regualar expression, case sensitive
                        Regexp reg = new Regexp(replaceDialog.sourceField.getText(), false);

                        resultString = reg.subAll(sourceString, replaceDialog.targetField.getText());
                    } else {
                        StringBuffer resultStringBuffer = new StringBuffer(sourceString);

                        replace(resultStringBuffer, replaceDialog.sourceField.getText(), 
                            replaceDialog.targetField.getText(), true);
                        resultString = (String) resultStringBuffer.toString();
                    }

                    model.setValueAt(
                        (String) resultString, row,
                        selectedIndex);
                    mTable.editCellAt(row, selectedIndex);
                    mTable.getCellEditor().stopCellEditing();

                }

            }

            mTable.repaint();
            this.repaint();
            return;
        }
 
        if (e.getActionCommand().equals("CopyColumn")) {
            this.repaint();

            if (copyColumnDialog == null) {
                copyColumnDialog = new JTagCopyColumnDialog("Copy column", false, false);
                copyColumnDialog.setSize(300, 215);

                copyColumnDialog.allButton.setSelected(true);
                copyColumnDialog.source.addItem("Song title");
                copyColumnDialog.source.addItem("Artist");
                copyColumnDialog.source.addItem("Album");
                copyColumnDialog.source.addItem("Year");
                copyColumnDialog.source.addItem("Comment");

                copyColumnDialog.allButton.setSelected(true);
                copyColumnDialog.target.addItem("Song title");
                copyColumnDialog.target.addItem("Artist");
                copyColumnDialog.target.addItem("Album");
                copyColumnDialog.target.addItem("Year");
                copyColumnDialog.target.addItem("Comment");

                copyColumnDialog.okButton.addActionListener(this);
                copyColumnDialog.okButton.setActionCommand("CopyColumnOk");

                copyColumnDialog.cancelButton.addActionListener(this);
                copyColumnDialog.cancelButton.setActionCommand("CopyColumnCancel");

                copyColumnDialog.setLocationRelativeTo(this);
            }

            copyColumnDialog.setVisible(true);
        }
        if (e.getActionCommand().equals("PrefsOk")) {
            setPreferences();
            return;
        }

        if (e.getActionCommand().equals("CopyColumnOk")) {
            if (mTable == null)
                return;

            // If  source and target are the same exit
            if (copyColumnDialog.source.getSelectedIndex() == copyColumnDialog.target.getSelectedIndex())
                return;

            // Get selected index
            int sourceSelectedIndex = copyColumnDialog.source.getSelectedIndex();
            int targetSelectedIndex = copyColumnDialog.target.getSelectedIndex();

            TableModel model = mTable.getModel();

            //TableColumnModel colModel = mTable.getColumnModel();

            // Check if the whole table has to be updated
            if (copyColumnDialog.allButton.isSelected()) {
                int numRows = mTable.getRowCount();

                for (int row = 0; row < numRows; row++) {
                    String sourceString = (String) model.getValueAt(row, sourceSelectedIndex);
                    String targetString = (String) model.getValueAt(row, targetSelectedIndex);
             
                    // Do next row in loop if target should only be inserted if not empty and target has a value
                    if (copyColumnDialog.onlyIfEmpty.isSelected() && targetString.trim().length() != 0)
                        continue;

                    model.setValueAt(
                        (String) sourceString, row,
                        targetSelectedIndex);
                    mTable.editCellAt(row, targetSelectedIndex);
                    mTable.getCellEditor().stopCellEditing();

                }
            } else {
                int selectedRows[] = mTable.getSelectedRows();

                // if now rows have been selected return
                if (selectedRows.length == 0)
                    return;

                for (int i = 0; i < selectedRows.length; i++) {
                    int row = selectedRows[i];
               
                    String sourceString = (String) model.getValueAt(row, sourceSelectedIndex);
                    String targetString = (String) model.getValueAt(row, targetSelectedIndex);
             
                    // Do next row in loop if target should only be inserted if not empty and target has a value
                    if (copyColumnDialog.onlyIfEmpty.isSelected() && targetString.trim().length() != 0)
                        continue;

                    model.setValueAt(
                        (String) sourceString, row,
                        targetSelectedIndex);
                    mTable.editCellAt(row, targetSelectedIndex);
                    mTable.getCellEditor().stopCellEditing();

                }
            }

            mTable.repaint();
            this.repaint();
            return;
        }

        if (e.getActionCommand().equals("CopyColumnCancel")) {
            copyColumnDialog.setVisible(false);
            this.repaint();
            return;
        }

        if (e.getActionCommand().equals("ConvertCase")) {
            this.repaint();

            if (convertCaseDialog == null) {
                convertCaseDialog =
                        new JTagConvertCaseDialog("Convert case",
                            false, false);
                convertCaseDialog.setSize(300, 215);

                convertCaseDialog.setLocationRelativeTo(this);

                // Set default values
                convertCaseDialog.allButton.setSelected(true);
                convertCaseDialog.convCharsField.setText(" _-([@");

                convertCaseDialog.allButton.setSelected(true);
                convertCaseDialog.choice.addItem("Song title");
                convertCaseDialog.choice.addItem("Artist");
                convertCaseDialog.choice.addItem("Album");
                convertCaseDialog.choice.addItem("Year");
                convertCaseDialog.choice.addItem("Comment");
                convertCaseDialog.choice.addItem("Filename");
            
                convertCaseDialog.okButton.addActionListener(this);
                convertCaseDialog.okButton.setActionCommand("ConvertCaseOk");

                convertCaseDialog.cancelButton.addActionListener(this);
                convertCaseDialog.cancelButton.setActionCommand("ConvertCaseCancel");
            }
            convertCaseDialog.setVisible(true);
        }

        if (e.getActionCommand().equals("ConvertCaseOk")) {
            if (mTable == null)
                return;

            // If textfield is empty
            // if(convertCaseDialog.convCharsField.getText().equals(""))
            //return;


            TableModel model = mTable.getModel();
            //TableColumnModel colModel = mTable.getColumnModel();

            // Get selected index
            int selectedIndex = convertCaseDialog.choice.getSelectedIndex();

            // If filename is selected selectedIndex = 6
            if (selectedIndex == 5)
                selectedIndex = 6;

            // Check if the whole table has to be updated
            if (convertCaseDialog.allButton.isSelected()) {
                int numRows = mTable.getRowCount();

                for (int row = 0; row < numRows; row++) {
                    String orgString = (String) model.getValueAt(row, selectedIndex);
                    StringBuffer resultBuffer = new StringBuffer(orgString);

                    resultBuffer = convertCase(resultBuffer, convertCaseDialog.convCharsField.getText());

                    model.setValueAt(
                        resultBuffer.toString(), row,
                        selectedIndex);
                    mTable.editCellAt(row, selectedIndex);
                    mTable.getCellEditor().stopCellEditing();

                }
            } else {
                int selectedRows[] = mTable.getSelectedRows();

                // if now rows have been selected return
                if (selectedRows.length == 0)
                    return;

                for (int i = 0; i < selectedRows.length; i++) {
                    int row = selectedRows[i];
              
                    String orgString = (String) model.getValueAt(row, selectedIndex);
                    StringBuffer resultBuffer = new StringBuffer(orgString);

                    resultBuffer = convertCase(resultBuffer, convertCaseDialog.convCharsField.getText());

                    model.setValueAt(
                        resultBuffer.toString(), row,
                        selectedIndex);
                    mTable.editCellAt(row, selectedIndex);
                    mTable.getCellEditor().stopCellEditing();

                }
            }

            mTable.repaint();
            this.repaint();
            return;
        }

        if (e.getActionCommand().equals("ConvertCaseCancel")) {
            convertCaseDialog.setVisible(false);
            this.repaint();
            return;
        }

        if (e.getActionCommand().equals("Auto-generateFilename")) {
            this.repaint();

            if (generateFilenameDialog == null) {
                generateFilenameDialog =
                        new JTagGenerateFilenameDialog("Auto-generate filename",
                            false, false);
                generateFilenameDialog.setSize(300, 215);

                // Set default values
                generateFilenameDialog.allButton.setSelected(true);
                generateFilenameDialog.substSpaces.setSelected(true);
                generateFilenameDialog.textField.setText("%a - %s.mp3");
            
                generateFilenameDialog.okButton.addActionListener(this);
                generateFilenameDialog.okButton.setActionCommand("Auto-generateOk");

                generateFilenameDialog.cancelButton.addActionListener(this);
                generateFilenameDialog.cancelButton.setActionCommand("Auto-generateCancel");

                generateFilenameDialog.setLocationRelativeTo(this);
            }

            generateFilenameDialog.setVisible(true);
        }
       
        if (e.getActionCommand().equals("Auto-generateOk")) {
            if (mTable == null)
                return;

            // If textfield is empty
            if (generateFilenameDialog.textField.getText().equals(""))
                return;

            TableModel model = mTable.getModel();

            //TableColumnModel colModel = mTable.getColumnModel();

            // Check if the whole table has to be updated
            if (generateFilenameDialog.allButton.isSelected()) {
                int numRows = mTable.getRowCount();

                for (int row = 0; row < numRows; row++) {
                    String songString = (String) model.getValueAt(row, 0);
                    String artistString = (String) model.getValueAt(row, 1);
                    String albumString = (String) model.getValueAt(row, 2);
                    String numberString = new String("" + (row + 1));

                    if (numberString.length() < 2)
                        numberString = "0" + numberString;
             
                    StringBuffer resultBuffer = new StringBuffer(generateFilenameDialog.textField.getText());

                    // Substitue the fields
                    replace(resultBuffer, "%n", numberString, true);
                    replace(resultBuffer, "%s", songString, true);
                    replace(resultBuffer, "%a", artistString, true);
                    replace(resultBuffer, "%t", albumString, true);

                    // Check if spaces should be replaced by _
                    if (generateFilenameDialog.substSpaces.isSelected())
                        replace(resultBuffer, " ", "_", true);

                    model.setValueAt(
                        resultBuffer.toString(), row,
                        6);
                    mTable.editCellAt(row, 6);
                    mTable.getCellEditor().stopCellEditing();

                }
            } else {
                int selectedRows[] = mTable.getSelectedRows();

                // if now rows have been selected return
                if (selectedRows.length == 0)
                    return;

                for (int i = 0; i < selectedRows.length; i++) {
                    int row = selectedRows[i];
               
                    String songString = (String) model.getValueAt(row, 0);
                    String artistString = (String) model.getValueAt(row, 1);
                    String albumString = (String) model.getValueAt(row, 2);
                    String numberString = new String("" + (i + 1));

                    if (numberString.length() < 2)
                        numberString = "0" + numberString;
             
                    StringBuffer resultBuffer = new StringBuffer(generateFilenameDialog.textField.getText());

                    // Substitue the fields
                    replace(resultBuffer, "%n", numberString, true);
                    replace(resultBuffer, "%s", songString, true);
                    replace(resultBuffer, "%a", artistString, true);
                    replace(resultBuffer, "%t", albumString, true);

                    // Check if spaces should be replaced by _
                    if (generateFilenameDialog.substSpaces.isSelected())
                        replace(resultBuffer, " ", "_", true);

                    model.setValueAt(
                        resultBuffer.toString(), row,
                        6);
                    mTable.editCellAt(row, 6);
                    mTable.getCellEditor().stopCellEditing();

                }
            }

            mTable.repaint();
            this.repaint();
            return;
        }

        if (e.getActionCommand().equals("Auto-generateCancel")) {
            generateFilenameDialog.setVisible(false);
            this.repaint();
            return;
        }

        if (e.getActionCommand().equals("GenerateFromFilename")) {
            this.repaint();

            if (generateDialog == null) {
                generateDialog =
                        new JTagGenerateFromFilenameDialog("Generate Song title/Artist from filename",
                            false, false);
                generateDialog.setSize(300, 215);
                generateDialog.allButton.setSelected(true);
                generateDialog.choice.addItem("Song title");
                generateDialog.choice.addItem("Artist");

                generateDialog.choice.setSelectedItem((String) "Artist");

                generateDialog.okButton.addActionListener(this);
                generateDialog.okButton.setActionCommand("GenerateOk");

                generateDialog.cancelButton.addActionListener(this);
                generateDialog.cancelButton.setActionCommand("GenerateCancel");

                generateDialog.setLocationRelativeTo(this);
            }

            generateDialog.setVisible(true);
        }

        if (e.getActionCommand().equals("GenerateCancel")) {
            generateDialog.setVisible(false);
            this.repaint();
            return;
        }

        if (e.getActionCommand().equals("GenerateOk")) {
            if (mTable == null)
                return;

            if (generateDialog.textField.getText().length() == 0)
                return;

            // Index 0=Song title 1=Artist
            int index = generateDialog.choice.getSelectedIndex();

            TableModel model = mTable.getModel();

            //TableColumnModel colModel = mTable.getColumnModel();

            // Check if the whole table has to be updated
            if (generateDialog.allButton.isSelected()) {
                int numRows = mTable.getRowCount();

                for (int row = 0; row < numRows; row++) {

                    String filename =
                        new String(model.getValueAt(row, 6).toString());

                    int posOfSep = filename.indexOf(
                            generateDialog.textField.getText());

                    if (posOfSep == -1)
                        return;

                    String fieldOne =
                        new String(filename.substring(0, posOfSep).trim());

                    String fieldTwo = new String("");

                    if (posOfSep != filename.lastIndexOf("."))
                        fieldTwo = new String(filename.substring(posOfSep +
                                        generateDialog.textField.getText().length(),
                                        filename.lastIndexOf(".")).trim());

                    // If Song title
                    if (index == 0) {
                        model.setValueAt((String) fieldOne, row, 0);
                        mTable.editCellAt(row, 0);
                        mTable.getCellEditor().stopCellEditing();

                        model.setValueAt((String) fieldTwo, row, 1);
                        mTable.editCellAt(row, 1);
                        mTable.getCellEditor().stopCellEditing();
                    }

                    // If Artist
                    if (index == 1) {
                        model.setValueAt((String) fieldOne, row, 1);
                        mTable.editCellAt(row, 1);
                        mTable.getCellEditor().stopCellEditing();

                        model.setValueAt((String) fieldTwo, row, 0);
                        mTable.editCellAt(row, 0);
                        mTable.getCellEditor().stopCellEditing();
                    }
                }
            } else {
                int selectedRows[] = mTable.getSelectedRows();

                // if now rows have been selected return
                if (selectedRows.length == 0)
                    return;

                for (int i = 0; i < selectedRows.length; i++) {
                    int row = selectedRows[i];

                    String filename =
                        new String(model.getValueAt(row, 6).toString());

                    int posOfSep = filename.indexOf(
                            generateDialog.textField.getText());

                    if (posOfSep == -1)
                        return;

                    String fieldOne =
                        new String(filename.substring(0, posOfSep).trim());

                    String fieldTwo = new String("");

                    if (posOfSep != filename.lastIndexOf("."))
                        fieldTwo = new String(filename.substring(posOfSep +
                                        generateDialog.textField.getText().length(),
                                        filename.lastIndexOf(".")).trim());

                    // If Song title
                    if (index == 0) {
                        model.setValueAt((String) fieldOne, row, 0);
                        mTable.editCellAt(row, 0);
                        mTable.getCellEditor().stopCellEditing();

                        model.setValueAt((String) fieldTwo, row, 1);
                        mTable.editCellAt(row, 1);
                        mTable.getCellEditor().stopCellEditing();
                    }

                    // If Artist
                    if (index == 1) {
                        model.setValueAt((String) fieldOne, row, 1);
                        mTable.editCellAt(row, 1);
                        mTable.getCellEditor().stopCellEditing();

                        model.setValueAt((String) fieldTwo, row, 0);
                        mTable.editCellAt(row, 0);
                        mTable.getCellEditor().stopCellEditing();
                    }
                }
            }

            mTable.repaint();
            this.repaint();
            return;
        }

        if (e.getActionCommand().equals("genreListSel")) {
            System.out.println("Changed!!");
            return;
        }

        if ((mThread != null) && mThread.isAlive()) {
            // If thread is still active, don't allow any
            // other threads to run
            return;
        } else {
            mAction = new String(e.getActionCommand());
            mThread = new Thread(this);
            mThread.start();
        }
    }

    public void run() {
        if (mAction == null)
            return;

        // EXIT
        if (mAction.equals("Exit")) {
            System.exit(0);
        }

        // OPEN
        if (mAction.equals("Open")) {
            handleOpenEvent();
            mErrorPanel.add("Center", mTextAreaScroller);
            this.repaint();
        }

        // RELOAD
        if (mAction.equals("Reload")) {
            handleReloadEvent();
            mErrorPanel.add("Center", mTextAreaScroller);
            this.repaint();
        }

        // SAVE
        if (mAction.equals("Save")) {
            handleSaveEvent();
            this.repaint();
        }

        // SAVE DB
        if (mAction.equals("SaveDb")) {
            handleSaveDbEvent();
            this.repaint();
        }

        // SYNC
        if (mAction.equals("Sync")) {
            handleSyncEvent();
            this.repaint();
        }

        // SYNC SELECTED
        if (mAction.equals("Sync selected")) {
            handleSyncSelectedEvent();
            this.repaint();
        }
        // Preferences...
        if (mAction.equals("Preferences")) {
            handlePreferencesEvent();
            this.repaint();
        }

        // SAVE Preferences
        if (mAction.equals("SavePrefs")) {
            savePreferences();
            this.repaint();
        }

        // Mp3Header
        if (mAction.equals("Mp3Header")) {
            handleMp3HeaderEvent();
            this.repaint();
        }

        if (mAction.equals("ConcatMP3s")) {
            ConcatMp3 frame = new ConcatMp3("Concat MP3s...");

            frame.setSize(600, 400);
            Image frameImage = Toolkit.getDefaultToolkit().getImage("images" + File.separator + "play.gif");

            frame.setIconImage(frameImage);
 
            centerFrame(frame);

            frame.show();
        }

        // Content
        if (mAction.equals("Documentation")) {
            JTagContentsDialog dialog = new JTagContentsDialog("JTag Documentation");

            centerFrame(dialog);
        }

        // About
        if (mAction.equals("About")) {
            JTagAboutDialog aboutDialog =
                new JTagAboutDialog("About JTag - Version 0.27.002",
                    true, false);

            aboutDialog.setLocationRelativeTo(this);
            aboutDialog.show();
            this.repaint();
        }

        // PLAY
        if (mAction.equals("Play")) {
            // If there is no table present, exit
            if (mTable == null)
                return;

            int selectedRow = mTable.getSelectedRow();

            //If no row has been selected
            if (selectedRow == -1)
                return;

            TableModel model = mTable.getModel();
            String fileName =
                new String(model.getValueAt(selectedRow, 6).toString());

            Integer index = new Integer((String) model.getValueAt(selectedRow, 7));
            mp3Info inf = (mp3Info) fileVector.elementAt(index.intValue());

            try {
                Runtime.getRuntime().exec(mMpPlayer + " " + "\"" +
                    inf.directoryName +
                    File.separator +
                    fileName + "\"");
            } catch (Exception playEx) {}
        }
    }

    // Handle OPEN event
    public void handleOpenEvent() {

        JFileChooser dirChooser;

        try {
            if (mTable != null) {
                if (new File(mTable.currentDirectory).exists())
                    dirChooser = new JFileChooser(mTable.currentDirectory);
                else
                    dirChooser = new JFileChooser();
            } else {
                dirChooser = new JFileChooser();
            }
        } catch (Exception ex) {
            // If something goes wrong, display user's home directory
            dirChooser = new JFileChooser();
        }

        dirChooser.setDialogTitle("Choose input directory");
        dirChooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);

        int returnValue = dirChooser.showOpenDialog(this);

        if (returnValue == JFileChooser.CANCEL_OPTION)
            return;

        File inputDir = dirChooser.getSelectedFile();

        if (inputDir == null)
            return;

        mCurrentFileDir = inputDir;
        getDirectoryContent(inputDir, recurseDirsItem.getState());

        // Adjust menu settings to table
        if (sizeTableItem.isSelected()) {
            mTable.setAutoResizeMode(JTable.AUTO_RESIZE_ALL_COLUMNS);
            mTable.repaint();
        } else {
            mTable.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
            mTable.repaint();
        }
    }

    // Handle RELOAD event
    public void handleReloadEvent() {
        if (mCurrentFileDir == null)
            return;

        getDirectoryContent(mCurrentFileDir, recurseDirsItem.getState());

        // Adjust menu settings to table
        if (sizeTableItem.isSelected()) {
            mTable.setAutoResizeMode(JTable.AUTO_RESIZE_ALL_COLUMNS);
            mTable.repaint();
        } else {
            mTable.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
            mTable.repaint();
        }

    }

    // Read the directory content
    private void getDirectoryContent(File inputDir) {
        getDirectoryContent(inputDir, false);
    }

    private void getDirectoryContent(File inputDir, boolean recursive) {

        fileVector = new Vector();

        walkDir(inputDir, fileVector, recursive);

        // Clear the text window
        mTextArea.setText("");

        // Now set up the table
        String headers[] = {"Song title", "Artist", "Album", "Year", "Comment",
                "Genre", "Filename", "Index", "Directory"};
        Object data[][] = new Object[fileVector.size()][headers.length];

        resetProgressBar();
        setProgressBarMinMax(0, fileVector.size());

        // No longer needed
        //fileHash   = new Hashtable();

        int i = 0;

        for (Enumeration enum = fileVector.elements();
            enum.hasMoreElements(); i++) {

            setProgressBarValue(i);

            mp3Info info = (mp3Info) enum.nextElement();

            //fileHash.put(info.fileName,new Integer(i));

            if (!info.hasIdTag) {
                mTextArea.append("No ID3 Tag:    " + info.fileName.trim() +
                    "\r\n");
                data[i][0] = "No ID3 Tag";
                data[i][1] = "";
                data[i][2] = "";
                data[i][3] = "";
                data[i][4] = "";
                data[i][5] = "";
                data[i][6] = info.fileName.trim();
                data[i][7] = Integer.toString(i);

                String dirName = (String) info.directoryName;

                dirName = dirName.substring(dirName.lastIndexOf(File.separator) + 1);
                data[i][8] = dirName;
            } else {
                data[i][0] = info.songTitle.trim();
                data[i][1] = info.artist.trim();
                data[i][2] = info.album.trim();
                data[i][3] = info.year.trim();
                data[i][4] = info.comment.trim();
                data[i][5] = info.genre.trim();
                //data[i][5]=new Boolean(true);
                data[i][6] = info.fileName.trim();
                data[i][7] = Integer.toString(i);

                String dirName = (String) info.directoryName;

                dirName = dirName.substring(dirName.lastIndexOf(File.separator) + 1);
                data[i][8] = dirName;
            }

        }

        resetProgressBar();

        if (mTable != null)
            mTablePanel.remove(mTable.mScroller);

        JTagTableModel mModel = new JTagTableModel(data, headers);
        TableSorter sorter = new TableSorter(mModel);

        mTable = new JTagTable(mTablePanel, inputDir.toString(), sorter);

        // Do not auto resize table
        mTable.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);

        sorter.addMouseListenerToHeaderInTable(mTable);

        // Aktionlistener for changes in combo box
        mTable.comboBox.addActionListener(this);
        mTable.comboBox.setActionCommand("ComboChanged");

        // Hide the index column
        TableColumnModel colModel = mTable.getColumnModel();

        colModel.getColumn(7).setMinWidth(0);
        colModel.getColumn(7).setMaxWidth(0);
        colModel.getColumn(7).setPreferredWidth(0);

        if (!showDirColumnItem.isSelected()) {
            colModel.getColumn(8).setMinWidth(0);
            colModel.getColumn(8).setMaxWidth(0);
        } else {
            // Borrow  width from filename column
            colModel.getColumn(8).setMinWidth(colModel.getColumn(6).getMinWidth());
            colModel.getColumn(8).setMaxWidth(colModel.getColumn(6).getMaxWidth());
            colModel.getColumn(8).setWidth(colModel.getColumn(6).getWidth());
        }

        mTable.showTable();
        //mTabbedPane.paint(mTabbedPane.getGraphics());
        this.show();

        // Now we add the genre window of already selected
        // genres
        //if(genreDialog != null)
        //genreDialog.genreList.setListData(new Vector());
        comboVect = new Vector();
        topOfCombo = new Hashtable();

        // Now update the genre list
        updateGenreList();

        // Add directory name to frame title
        this.setTitle("JTag - " + mTable.currentDirectory);

    }

    // Read directories
    private void walkDir(File dir, Vector vect, boolean recursive) {
        String list[] = dir.list();

        for (int i = 0; i < list.length; i++) {
            File curFile = new File(dir.toString() + File.separator + list[i]);

            if (curFile.isDirectory()) {
                // Walk recurively if specified
                if (recursive) {
                    walkDir(curFile, vect, recursive);
                }
            } else if (curFile.isFile()) {
                // If it's a file, do the file stuff...
                if (curFile.toString().endsWith("mp3") ||
                    curFile.toString().endsWith("MP3")) {
                    fileVector.add(new mp3Info(dir.toString(), list[i]));
                }
            } else {
                // Shouldn't happen, but just in case...
                System.out.println("Unknown file ... " + list[i]);
            }
        }
    }

    // Handle SAVE Event
    public void handleSaveEvent() {
        // If the table is empty ignore it
        if (mTable == null)
            return;

        JFileChooser fileChooser = new JFileChooser();

        fileChooser.setDialogTitle("Choose output file");

        int returnValue = fileChooser.showSaveDialog(this);

        if (returnValue == JFileChooser.CANCEL_OPTION)
            return;

        File outputFile = fileChooser.getSelectedFile();

        if (outputFile == null)
            return;

        try {
            writeFile w = new writeFile(outputFile.toString());

            String sc;

            // Set separation charavter
            if (mSepCharacter.equals("TAB"))
                sc = "\t";
            else
                sc = mSepCharacter;

            // Write header
            for (int i = 0; i < mOutputVector.size(); i++) {
                w.write((String) mOutputVector.elementAt(i));

                if (i != mOutputVector.size() - 1)
                    w.write(sc);

            }

            w.writeLine("");

            int numRows = mTable.getRowCount();
            int numCols = mTable.getColumnCount();
            TableModel model = mTable.getModel();

            resetProgressBar();
            setProgressBarMinMax(0, numRows);

            for (int row = 0; row < numRows; row++) {
                setProgressBarValue(row);

                String line = new String();
                String column = new String();

                for (int i = 0; i < mOutputVector.size(); i++) {

                    String item = (String) mOutputVector.elementAt(i);

                    if (item.equals("Song title"))
                        column = model.getValueAt(row, 0).toString();
                    else if (item.equals("Artist"))
                        column = model.getValueAt(row, 1).toString();
                    else if (item.equals("Album"))
                        column = model.getValueAt(row, 2).toString();
                    else if (item.equals("Year"))
                        column = model.getValueAt(row, 3).toString();
                    else if (item.equals("Comment"))
                        column = model.getValueAt(row, 4).toString();
                    else if (item.equals("Genre")) {
                        column = model.getValueAt(row, 5).toString();
                        if (column.equals(" "))
                            column = "";
                    } else if (item.equals("Filename"))
                        column = model.getValueAt(row, 6).toString();
                    else if (item.equals("Directory"))
                        column = mTable.currentDirectory;
                    else {
                        String fileName =
                            new String(model.getValueAt(row, 6).toString());
                        //Integer index = (Integer)fileHash.get(fileName);
                        //mp3Info inf = (mp3Info)fileVector.elementAt(index.intValue());
                        Integer index =
                            new Integer((String) model.getValueAt(row, 7));
                        mp3Info inf = (mp3Info) fileVector.elementAt(
                                index.intValue());

                        column = inf.getMp3HeaderValue(item);
                    }

                    if (i != mOutputVector.size() - 1)
                        line = line + column + sc;
                    else
                        line = line + column;

                }

                w.writeLine(line);

            }

            resetProgressBar();

            w.close();

        } catch (Exception e) {}
    }

    // HANDLE SAVE DB EVENT
    public void handleSaveDbEvent() {
        if (mTable == null)
            return;

        String passwd = new String("");

        if (mDbUser.length() > 0 && mDbUser != null) {
            // Ask for password

            JPasswordField pass = new JPasswordField();
            String messageText =
                new String("Enter password for user " + mDbUser);
            Object messages[] = new Object[2];

            messages[0] = messageText;
            messages[1] = pass;

            JOptionPane passPane = new JOptionPane(messages,
                    JOptionPane.WARNING_MESSAGE,
                    JOptionPane.OK_CANCEL_OPTION, null);
            JDialog passDialog = passPane.createDialog(this, "Authentication");

            passDialog.show();

            if (passPane.getValue() != null) {
                int retval = ((Integer) passPane.getValue()).intValue();

                if (retval == JOptionPane.OK_OPTION)
                    passwd = new String(pass.getPassword());
                else
                    return;
            }
        } else {
            passwd = new String("");
        }
        JTagDbDialog dbDialog =
            new JTagDbDialog("Export table into database", true,
                false, mDbUser, passwd, mDbURL, mDbDriver, mTable, this);

        dbDialog.show();
        // call the function to diskply DB dialog
    }

    // Handle SYNC event
    public void handleSyncEvent() {

        // If the table is empty ignore it
        if (mTable == null)
            return;

        int numRows = mTable.getRowCount();
        TableModel model = mTable.getModel();

        // If the table has no rows, return
        if (numRows == 0)
            return;

        resetProgressBar();
        setProgressBarMinMax(0, numRows);

        for (int row = 0; row < numRows; row++) {
            setProgressBarValue(row);

            String title = new String(model.getValueAt(row, 0).toString());
            String artist = new String(model.getValueAt(row, 1).toString());
            String album = new String(model.getValueAt(row, 2).toString());
            String year = new String(model.getValueAt(row, 3).toString());
            String comment = new String(model.getValueAt(row, 4).toString());
            String genre = new String(model.getValueAt(row, 5).toString());
            String filename = new String(model.getValueAt(row, 6).toString());

            // Skip if no ID3 Tag is present
            //if(title.equals("No ID3 Tag"))
            //continue;

            // Check if filename has changed
            //mp3Info inf = (mp3Info)fileVector.elementAt(row);
            Integer index = new Integer((String) model.getValueAt(row, 7));
            mp3Info inf = (mp3Info) fileVector.elementAt(index.intValue());

            if (!filename.equals(inf.fileName)) {
                // Rename the file
                File changeFile = new File(inf.directoryName + File.separator +
                        inf.fileName);

                if (!changeFile.renameTo(
                        new File(inf.directoryName + File.separator +
                            filename))) {
                    mTextArea.append("ERROR: " +
                        "Could not rename file \"" + inf.fileName);
                    mTextArea.append("\" to \"" + filename + "\" ...skipping\r\n");
                    continue;
                } else {
                    // Update fileHash hashtable
                    //fileHash.remove((String)inf.fileName);
                    //fileHash.put(filename, new Integer(row));
                    //Adjust filename in mp3Info
                    inf.fileName = filename;
                }
            }

            writeId3 writeFile =
                new writeId3(mTextArea, inf.directoryName, filename,
                    title, artist, album, year, comment, genre);
        }
        resetProgressBar();
    }

    // Handle Mp3Header event
    public void handleMp3HeaderEvent() {

        // If the table is empty ignore it
        if (mTable == null)
            return;

        TableModel model = mTable.getModel();
        int selectedRows[] = mTable.getSelectedRows();

        // if now rows have been selected return
        if (selectedRows.length == 0)
            return;

        String fileName =
            new String(model.getValueAt(selectedRows[0], 6).toString());
        //Integer index = (Integer)fileHash.get(fileName);
        //mp3Info inf = (mp3Info)fileVector.elementAt(index.intValue());
        Integer index =
            new Integer((String) model.getValueAt(selectedRows[0], 7));
        mp3Info inf = (mp3Info) fileVector.elementAt(index.intValue());

        JTagMp3HeaderDialog hd =
            new JTagMp3HeaderDialog("MP3 Header Info - " + fileName,
                true, true, inf, this);

        hd.setSize(300, 300);
        hd.setLocationRelativeTo(this);
        hd.show();

    }

    // Handle SYNC SELECTED event
    public void handleSyncSelectedEvent() {

        // If the table is empty ignore it
        if (mTable == null)
            return;

        TableModel model = mTable.getModel();
        int selectedRows[] = mTable.getSelectedRows();

        // if now rows have been selected return
        if (selectedRows.length == 0)
            return;

        resetProgressBar();
        setProgressBarMinMax(0, selectedRows.length);

        for (int i = 0; i < selectedRows.length; i++) {
            setProgressBarValue(i);

            int row = selectedRows[i];

            String title = new String(model.getValueAt(row, 0).toString());
            String artist = new String(model.getValueAt(row, 1).toString());
            String album = new String(model.getValueAt(row, 2).toString());
            String year = new String(model.getValueAt(row, 3).toString());
            String comment = new String(model.getValueAt(row, 4).toString());
            String genre = new String(model.getValueAt(row, 5).toString());
            String filename = new String(model.getValueAt(row, 6).toString());

            // Skip if no ID3 Tag is present
            //if(title.equals("No ID3 Tag"))
            //	continue;

            // Check if filename has changed
            //mp3Info inf = (mp3Info)fileVector.elementAt(row);
            Integer index = new Integer((String) model.getValueAt(row, 7));
            mp3Info inf = (mp3Info) fileVector.elementAt(index.intValue());

            if (!filename.equals(inf.fileName)) {
                // Rename the file
                File changeFile = new File(inf.directoryName + File.separator +
                        inf.fileName);

                if (!changeFile.renameTo(
                        new File(inf.directoryName + File.separator +
                            filename))) {
                    mTextArea.append("ERROR: " +
                        "Could not rename file \"" + File.separator +
                        inf.fileName);
                    mTextArea.append("\" to \"" + filename + "\" ...skipping\r\n");
                    continue;
                } else {
                    // Update fileHash hashtable
                    //fileHash.remove((String)inf.fileName);
                    //fileHash.put(filename, new Integer(row));
                    // Adjust filname in class id3Info
                    inf.fileName = filename;
                }
            }

            writeId3 writeFile =
                new writeId3(mTextArea, inf.directoryName,
                    filename, title, artist, album, year, comment, genre);
        }
        resetProgressBar();
    }

    void handlePreferencesEvent() {

        // Save options
        Vector p = new Vector();

        for (int i = 0; i < mOutputVector.size(); i++) {
            p.add((String) mOutputVector.elementAt(i));
        }

        prefs = new JTagPrefs("Preferences", true, false,
                    mp3ListEntries.getSortedVector(), p);
        prefs.buttonOk.addActionListener(this);
        prefs.buttonOk.setActionCommand("PrefsOk");

        prefs.buttonCancel.addActionListener(this);
        prefs.buttonCancel.setActionCommand("PrefsCancel");

        // Set the rest of the preferences
        if (mSepCharacter.equals("TAB") || mSepCharacter.length() == 0) {
            prefs.radioTab.setSelected(true);
        } else {
            prefs.radioOtherCharacter.setSelected(true);
            prefs.textSepChar.setText(mSepCharacter);
        }

        // Player option
        prefs.textMp3Player.setText(mMpPlayer);

        // Database options
        prefs.mDatabasePanel.userNameField.setText(mDbUser);
        prefs.mDatabasePanel.serverField.setText(mDbURL);
        prefs.mDatabasePanel.driverField.setText(mDbDriver);

        //Autosave option
        prefs.mSyncPanel.asaveField.setText(
            new Long(aSaveInterval).toString());

        prefs.setSize(500, 500);
        prefs.setLocationRelativeTo(this);
        prefs.show();

    }

    void setPreferences() {
        // Now let's save the preferences and then close the dialog
        mOutputVector = prefs.list2.listData;

        if (prefs.radioTab.isSelected() ||
            prefs.textSepChar.getText().length() == 0) {
            mSepCharacter = "TAB";
        } else {
            mSepCharacter = prefs.textSepChar.getText();
        }

        mMpPlayer = prefs.textMp3Player.getText();

        if (mMpPlayer.length() > 0) {
            playButton.setEnabled(true);
            playItem.setEnabled(true);
        } else {
            playButton.setEnabled(false);
            playItem.setEnabled(false);
        }

        mDbUser = prefs.mDatabasePanel.userNameField.getText();
        mDbURL = prefs.mDatabasePanel.serverField.getText();
        mDbDriver = prefs.mDatabasePanel.driverField.getText();

        // If no DB driver or URL is given
        if (mDbURL == null || mDbDriver == null || mDbURL.length() == 0 ||
            mDbDriver.length() == 0) {
            saveDbButton.setEnabled(false);
            saveDbItem.setEnabled(false);
        } else {
            saveDbButton.setEnabled(true);
            saveDbItem.setEnabled(true);
        }

        aSaveInterval =
                new Long(prefs.mSyncPanel.asaveField.getText()).longValue();

        if (asave != null)
            asave.stop = true;

        // If autosave time > 0 start a new autosave thread
        if (aSaveInterval > 0)
            asave = new autoSave(aSaveInterval, this);

        // Close the dialog
        prefs.dispose();
    }

    // Function to sava preferences
    public void savePreferences() {
        writeFile fileToWrite = new writeFile(".jtagrc");

        fileToWrite.writeLine("####################################");
        fileToWrite.writeLine("# JTAG configuration file          #");
        fileToWrite.writeLine("####################################");
        fileToWrite.writeLine("");
        fileToWrite.writeLine("# Everything with NULL is unset");
        fileToWrite.writeLine("");
        fileToWrite.writeLine("### Settings for Mp3 player");

        if (mMpPlayer == null || mMpPlayer.length() == 0)
            fileToWrite.writeLine("Mp3Player = " + "NULL");
        else
            fileToWrite.writeLine("Mp3Player = " + mMpPlayer);

        fileToWrite.writeLine("");

        fileToWrite.writeLine("### Settings for separation character");
        fileToWrite.writeLine("SepCharacter = " + mSepCharacter);

        fileToWrite.writeLine("");
        fileToWrite.writeLine("### Settings for output list");
        if (mOutputVector.size() == 0) {
            fileToWrite.writeLine("OutputList = " + "NULL");
        } else {
            fileToWrite.write("OutputList = ");
            for (int i = 0; i < mOutputVector.size(); i++) {
                fileToWrite.write((String) mOutputVector.elementAt(i));
                if (i != mOutputVector.size() - 1)
                    fileToWrite.write(",");
                else
                    fileToWrite.writeLine("");
            }
        }
        fileToWrite.writeLine("");
        fileToWrite.writeLine("### Settings for database connection");
        if (mDbUser == null || mDbUser.length() == 0) {
            fileToWrite.writeLine("DbUser = " + "NULL");
        } else {
            fileToWrite.writeLine("DbUser = " + mDbUser);
        }

        if (mDbURL == null || mDbURL.length() == 0) {
            fileToWrite.writeLine("DbURL = " + "NULL");
        } else {
            fileToWrite.writeLine("DbURL = " + mDbURL);
        }

        if (mDbDriver == null || mDbDriver.length() == 0) {
            fileToWrite.writeLine("DbDriver = " + "NULL");
        } else {
            fileToWrite.writeLine("DbDriver = " + mDbDriver);
        }

        fileToWrite.writeLine("");

        fileToWrite.writeLine("### Settings for autosave option");
        fileToWrite.writeLine("### Value is in seconds");
        fileToWrite.writeLine("AutoSave = " + aSaveInterval);

        // Close the configuration file
        fileToWrite.close();
    }

    // Functions to handle the progressbar

    public void resetProgressBar() {
        mProgressBar.setValue(0);
    }

    public void setProgressBarMinMax(int min, int max) {
        mProgressBar.setMinimum(min);
        mProgressBar.setMaximum(max);
    }

    public void setProgressBarValue(int value) {
        mProgressBar.setValue(value);
    }

    // Item event
    public void itemStateChanged(ItemEvent e) {
        if (e.getSource() == sizeTableItem &&
            e.getStateChange() == e.SELECTED) {
            if (mTable == null)
                return;
            mTable.setAutoResizeMode(JTable.AUTO_RESIZE_ALL_COLUMNS);
            mTable.repaint();
        } else if (e.getSource() == sizeTableItem &&
            e.getStateChange() == e.DESELECTED) {
            if (mTable == null)
                return;
            mTable.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
            mTable.repaint();
        } else if (e.getSource() == showDirColumnItem) {
            if (e.getStateChange() == e.DESELECTED) {
                //  Hide directory column
                TableColumnModel colModel = mTable.getColumnModel();

                colModel.getColumn(8).setMinWidth(0);
                colModel.getColumn(8).setMaxWidth(0);
            } else {
                //  Show directory column
                TableColumnModel colModel = mTable.getColumnModel();

                // Borrow  width from filename column
                colModel.getColumn(8).setMinWidth(colModel.getColumn(6).getMinWidth());
                colModel.getColumn(8).setMaxWidth(colModel.getColumn(6).getMaxWidth());
                colModel.getColumn(8).setPreferredWidth(colModel.getColumn(6).getWidth());
            }
            this.validateTree();
        } else if (e.getSource() == showToolbarItem &&
            e.getStateChange() == e.DESELECTED) {
            mToolBar.setVisible(false);
            this.validateTree();
        } else if (e.getSource() == showToolbarItem &&
            e.getStateChange() == e.SELECTED) {
            mToolBar.setVisible(true);
            this.validateTree();
        } else if (e.getSource() == showStatusbarItem &&
            e.getStateChange() == e.DESELECTED) {
            mProgressBar.setVisible(false);
            this.validateTree();
        } else if (e.getSource() == showStatusbarItem &&
            e.getStateChange() == e.SELECTED) {
            mProgressBar.setVisible(true);
            this.validateTree();
        } else if (e.getSource() == genreListItem &&
            e.getStateChange() == e.DESELECTED) {
            genreDialog.setVisible(false);
        } else if (e.getSource() == genreListItem &&
            e.getStateChange() == e.SELECTED) {
            genreDialog.setLocationRelativeTo(this);
            genreDialog.setVisible(true);
        }

    } // End of item event

    // Listener for selection changed in
    // Genre dialog list
    public void valueChanged(ListSelectionEvent e) {
        if (genreDialog.genreList.getSelectedValue() == null) {
            // Clear the selection
            genreDialog.genreList.clearSelection();
            return;
        }

        // If the table is empty ignore it
        if (mTable == null) {
            // Clear the selection
            genreDialog.genreList.clearSelection();
            return;
        }

        TableModel model = mTable.getModel();
        int selectedRows[] = mTable.getSelectedRows();

        // if now rows have been selected return
        if (selectedRows.length == 0) {
            // Clear the selection
            genreDialog.genreList.clearSelection();
            return;
        }

        String val = (String) genreDialog.genreList.getSelectedValue();

        for (int i = 0; i < selectedRows.length; i++) {
            int row = selectedRows[i];

            model.setValueAt(val, row, 5);
        }

        // Clear the selection
        genreDialog.genreList.clearSelection();

        // Update the table
        mTable.clearSelection();
    } // End of List selection listener

    public void updateGenreList() {

        // Stop the cell editing, otherwise the model will not be updated
        CellEditor cellEdit = mTable.getCellEditor();

        if (cellEdit != null) {
            cellEdit.stopCellEditing();
        }

        // The variable names including comboBox are
        // historic and shouldn't be taken to serious
        int numRows = mTable.getRowCount();
        int numCols = mTable.getColumnCount();
        TableModel model = mTable.getModel();

        Hashtable tableValues = new Hashtable();

        for (int row = 0; row < numRows; row++) {
            String column = model.getValueAt(row, 5).toString();

            if (tableValues.get(column) == null) {
                tableValues.put(column, new Integer(0));
            } else {

                // If already present, count the occurences
                // We don't need them now, but maybe later
                Integer IntVal = (Integer) tableValues.get(column);
                int ival = IntVal.intValue();

                ival++;
                tableValues.put(column, new Integer(ival));
            }
        }

        for (Enumeration enum = tableValues.keys(); enum.hasMoreElements();) {
            Object value = enum.nextElement();
            String strVal = new String((String) value);

            // if it doesn't exist and is not equals " "
            //if(topOfCombo.get(value) == null &&
            //!strVal.equals(" "))
            // " " should be also ok!
            if (topOfCombo.get(value) == null) {
                topOfCombo.put(value, new Integer(0));
            }
        }

        comboVect = new Vector();

        for (Enumeration enumTop = topOfCombo.keys();
            enumTop.hasMoreElements();) {
            Object valueTop = enumTop.nextElement();

            comboVect.add(valueTop);

        }

        // Sort the vector
        comboVect = sortVector(comboVect);

        // Add list to dialog
        genreDialog.genreList.setListData(comboVect);

    }

    private Vector sortVector(Vector vect) {
        int a, b;

        Vector newVect = new Vector(vect);

        for (a = 1; a < newVect.size(); a++)
            for (b = vect.size() - 1; b >= a; b--) {
                String element1 = (String) newVect.elementAt(b - 1);
                String element2 = (String) newVect.elementAt(b);

                if (element1.compareTo(element2) > 0) {

                    newVect.removeElementAt(b);
                    newVect.add(b, element1);
                    newVect.removeElementAt(b - 1);
                    newVect.add(b - 1, element2);
                }
            }
        return newVect;
    }

    // Replaces all instances of the String o with the String n in the
    // StringBuffer orig if all is true, or only the first instance if all is false.
    public static void replace(StringBuffer orig, String o, String n, boolean all) {
        if (orig == null || o == null || o.length() == 0 || n == null)
            throw new IllegalArgumentException("Null or zero-length String");

        int i = 0;

        while (i + o.length() <= orig.length()) {
            if (orig.substring(i, i + o.length()).equals(o)) {
                orig.replace(i, i + o.length(), n);
                if (!all)
                    break;
                else
                    i += n.length();
            } else
                i++;
        }
    }

    public StringBuffer convertCase(StringBuffer orig, String convString) {
        String lastChar = null;

        //Convert to lower case
        orig = new StringBuffer(new String(orig).toLowerCase());

        for (int i = 0; i < orig.length(); i++) {
            String character = orig.substring(i, i + 1);
            
            if (lastChar == null || convString.indexOf(lastChar) != -1)
                character = character.toUpperCase();

            orig.replace(i, i + 1, character);

            lastChar = new String(character);           
        }

        return orig;
    }   

    private void centerFrame(JFrame frame) {
        // Center frame on screen
        Dimension screenDim = Toolkit.getDefaultToolkit().getScreenSize();
        Rectangle frameDim = frame.getBounds();

        frame.setLocation((screenDim.width - frameDim.width) / 2, (screenDim.height - frameDim.height) / 2);
    }
 
    // Window Adapter for genre dialog
    private class genreWindowAdapter extends WindowAdapter {
        public void windowClosing(WindowEvent e) {
            genreListItem.setSelected(false);
        }
    } // End of window adapter

} // End of mainWindow

