package org.jtag.table;

import java.awt.*;
import java.awt.print.*;
import java.awt.event.*;
import java.io.*;
import javax.swing.*;
import javax.swing.table.*;
import javax.swing.event.*;
import java.util.*;

import org.jtag.id3.*;


public class JTagTable extends JTable {
    JPanel  mParentTablePanel;
    JScrollPane scroller;
    public String  currentDirectory;
    public JScrollPane mScroller;
    public JComboBox comboBox;
	
    public JTagTable(JPanel parent, String dir,
        Object headers[], Object data[][]) {
        super(data, headers);
        //mScroller = JTable.createScrollPaneForTable(this);
        mScroller = new JScrollPane(this); 
 
        mParentTablePanel = parent;
   
        // Get rid of trailing file separator if present
        if (dir.endsWith(File.separator))
            currentDirectory = new String(dir.substring(0, dir.length() - 1));
        else
            currentDirectory = new String(dir);
  
        doTable();
    }
	
    public JTagTable(JPanel parent, String dir,
        Object model) {
        super((TableModel) model);
        //mScroller = JTable.createScrollPaneForTable(this);
        mScroller = new JScrollPane(this); 
   
        mParentTablePanel = parent;
   
        // Get rid of trailing file separator if present
        if (dir.endsWith(File.separator))
            currentDirectory = new String(dir.substring(0, dir.length() - 1));
        else
            currentDirectory = new String(dir);
  
        doTable();
    }	
	
    private void doTable() {
        TableColumnModel colModel = this.getColumnModel();

        //----------------------------------
        // Cell renderer for fileName column
        //----------------------------------
        JTextField textField = new JTextField();

        // File names are no longer read only -- 10/12/99
        //textField.setEditable(false);
        DefaultCellEditor fileNameEditor = new DefaultCellEditor(textField);

        colModel.getColumn(6).setCellEditor(fileNameEditor);

        // Disable editing of index column (is not visible anyway)
        JTextField indexField = new JTextField();
        DefaultCellEditor indexEditor = new DefaultCellEditor(indexField);

        indexField.setEditable(false);
        colModel.getColumn(7).setCellEditor(indexEditor);

        // Renderer for directory column
        JTextField dirField = new JTextField();
        DefaultCellEditor dirEditor = new DefaultCellEditor(dirField);

        dirField.setEditable(false);
        colModel.getColumn(8).setCellEditor(dirEditor);

        //----------------------------------
        // Cell renderer for genre column
        //----------------------------------
        ComboBoxRenderer cbRenderer = new ComboBoxRenderer();

        comboBox = new JComboBox();
  	
        // Now fill the combo box with all genres
        comboBox.addItem(" ");
   
        id3Genre genre = new id3Genre();
   
        String sortedList[] = new String[genre.genre.length];

        sortedList = genre.getSortedList();
        for (int i = 0; i < sortedList.length; i++) {
            comboBox.addItem(sortedList[i]);
        }
   
        DefaultCellEditor genreEditor = new DefaultCellEditor(comboBox);
   
        colModel.getColumn(5).setCellEditor(genreEditor);
   
        //----------------------------------
        // Cell renderer for year column
        //----------------------------------
        JTagTableTextField yearField = new JTagTableTextField(4, true);
        DefaultCellEditor yearEditor = new DefaultCellEditor(yearField);

        colModel.getColumn(3).setCellEditor(yearEditor);
   
        //----------------------------------
        // Cell renderer for the rest
        //----------------------------------
        JTagTableTextField otherFields = new JTagTableTextField(30, false);
        DefaultCellEditor otherEditors = new DefaultCellEditor(otherFields);

        colModel.getColumn(0).setCellEditor(otherEditors);
        colModel.getColumn(1).setCellEditor(otherEditors);
        colModel.getColumn(2).setCellEditor(otherEditors);
        colModel.getColumn(4).setCellEditor(otherEditors);
  
    }
  
    public void showTable() {
        //this.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
        mParentTablePanel.add("Center", mScroller);
    }
   
    private class ComboBoxRenderer extends JComboBox
        implements TableCellRenderer {
        public ComboBoxRenderer() {
            super();
        }
   
        public Component getTableCellRendererComponent(
            JTable table,
            Object value,
            boolean isSelected,
            boolean hasFocus,
            int row,
            int column) {
            if (value != null)
                setSelectedItem(value);
   		
            return this;
        }
   	
    } // End of inner class ComboBoxRenderer
	
} // End of class JTagTable
